VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "CheckCube"
   ClientHeight    =   1245
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   2130
   LinkTopic       =   "Form1"
   ScaleHeight     =   1245
   ScaleWidth      =   2130
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdVerify 
      Caption         =   "Verify"
      Height          =   495
      Left            =   480
      TabIndex        =   0
      Top             =   360
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type Point
    X As Single
    Y As Single
    Z As Single
End Type

Private Type Edge
    Pt1 As Integer
    Pt2 As Integer
End Type

Private m_Points() As Point
Private m_Edges() As Edge

' Add a point to the m_Points array.
Private Sub MakePoint(ByVal X As Single, ByVal Y As Single, ByVal Z As Single)
Dim num_points As Integer

    ' Make room.
    On Error Resume Next
    num_points = UBound(m_Points)
    On Error GoTo 0
    num_points = num_points + 1
    ReDim Preserve m_Points(1 To num_points)

    ' Create the point.
    With m_Points(num_points)
        .X = X
        .Y = Y
        .Z = Z
    End With
End Sub

' Add an edge to the m_Edges array.
Private Sub MakeEdge(ByVal Pt1 As Integer, ByVal Pt2 As Integer)
Dim num_edges As Integer

    ' Make room.
    On Error Resume Next
    num_edges = UBound(m_Edges)
    On Error GoTo 0
    num_edges = num_edges + 1
    ReDim Preserve m_Edges(1 To num_edges)

    ' Create the edge.
    With m_Edges(num_edges)
        .Pt1 = Pt1
        .Pt2 = Pt2
    End With
End Sub


Private Sub cmdVerify_Click()
Dim is_ok As Boolean
Dim i As Integer
Dim dist As Single
Dim dx As Single
Dim dy As Single
Dim dz As Single

    ' Create the points.
    MakePoint -1, -1, -1
    MakePoint -1, 1, -1
    MakePoint 1, -1, -1
    MakePoint 1, 1, -1
    MakePoint -1, -1, 1
    MakePoint -1, 1, 1
    MakePoint 1, -1, 1
    MakePoint 1, 1, 1

    ' Make the edges.
    MakeEdge 1, 2
    MakeEdge 1, 3
    MakeEdge 2, 4
    MakeEdge 3, 4
    MakeEdge 1, 5
    MakeEdge 2, 6
    MakeEdge 3, 7
    MakeEdge 4, 8
    MakeEdge 5, 6
    MakeEdge 5, 7
    MakeEdge 6, 8
    MakeEdge 7, 8

    ' Verify that all edges are 2 units long.
    is_ok = True
    For i = 1 To UBound(m_Edges)
        With m_Edges(i)
            dx = m_Points(.Pt1).X - m_Points(.Pt2).X
            dy = m_Points(.Pt1).Y - m_Points(.Pt2).Y
            dz = m_Points(.Pt1).Z - m_Points(.Pt2).Z
            dist = Sqr(dx * dx + dy * dy + dz * dz)
            If Abs(2 - dist) > 0.00001 Then
                is_ok = False
                Exit For
            End If
        End With
    Next i

    If is_ok Then
        MsgBox "The edges are all 2 units long!"
    Else
        MsgBox "Oops. The edges are not all 2 units long."
    End If
End Sub
